unit Utils;

interface

uses SysUtils,math,DateUtils;

{Conversion de la date calendaire (calendrier julien puis grgorien) en jour julien)}
function jj(qu,ms,an,hr,mn:longint;sc:extended):extended;

{Rang du jour dans l'anne; }
function jda(qu,ms,an:longint):longint;

{Test si objet visible}
function IfVisible(ralpha,rdelta,long,lat,TimeZone:extended):Boolean;

{Calcul heure sidrale}
function HeureSiderale(long :extended;GMT : integer):extended;

{Calcul l'angle horaire}
function AH(long,alpha :extended;GMT : integer):extended;

{Calcul vitesse relative de King}
Function getKingSpeedCorrection(AH,Delta,Latitude:Double):Double;

{Conversion Azimuthale  Equatoriale}
procedure CalculeAlphaDeltaFromAZ(Ht,Az,Tsl:Double;var Alpha,Delta:double;Latitude,Longitude:Double);

{Calcul pour Correction de la Rfraction}
procedure CorrectionRefraction(var Alpha,Delta:Double;HeureSid:Double;Latitude,Longitude:Double);

{Calcul pour Correction inverse de la Rfraction}
procedure CorrectionRefractionInverse(var Alpha,Delta:Double;HeureSid:Double;Latitude,Longitude:Double);

{Conversion du jour julien en date calendaire; }
procedure cal(jd:extended;var qu,ms,an,hr,mn:longint;var sc:extended);

{Rduction  la date de la position d'un ple plantaire (utilis pour les phmrides physiques);}
procedure ReducPole(jd:extended;var a0,d0:extended);

{Calcul de la nutation pour un jour julien donn; }
procedure CalcNut(jd:extended;var dpsi,deps:extended);

implementation

procedure cal(jd:extended;var qu,ms,an,hr,mn:longint;var sc:extended);
var
 a,b,c,d,e,z,wrk:extended;
begin
 wrk:=jd+0.5;
 z:=int(wrk);
 wrk:=wrk-z;
 if (wrk<0) then
  begin
   z:=z-1;
   wrk:=wrk+1;
  end;
 hr:=trunc(24*wrk);
 mn:=trunc(1440*wrk);
 sc:=86400.0*wrk;
 sc:=sc-60*mn;
 mn:=mn mod 60;
 a:=z;
 if (z>2299160) then
  begin
   a:=int((4*z-7468865)/146097);
   a:=z+1+a-int(a/4);
  end;
 b:=a+1524;
 c:=int(40*b-4884);
 if (c<0) then c:=c-14609;
 c:=int(c/14610);
 d:=c*1461;
 if (d<0) then d:=d-3;
 d:=int(d/4);
 e:=int((5*(b-d))/153);
 qu:=round(b-d-int(30.6001*e));
 ms:=round(e-1);
 an:=round(c-4716);
 if (ms>12) then
  begin
   an:=an+1;
   ms:=ms-12;
  end;
 if (qu=0) then
  begin
   ms:=ms-1;
   qu:=31;
  end;
end;

function jj(qu,ms,an,hr,mn:longint;sc:extended):extended;
var
 x,y,wrk:extended;
begin
 wrk:=((an*100+ms)*100+qu)/10000;
 x:=an;
 y:=ms+1;
 if (ms<3) then
  begin
   x:=x-1;
   y:=y+12;
  end;
 if (wrk<1582.1015) then wrk:=0 else wrk:=2-int(x/100)+int(x/400);
 wrk:=wrk+qu+int(30.6001*y);
 if (x<0) then wrk:=wrk+int(365.25*x-0.75) else wrk:=wrk+int(365.25*x);
 jj:=1720994.5+wrk+((hr*60+mn)*60+sc)/86400.0;
end;

function jda(qu,ms,an:longint):longint;
begin
 jda:=trunc(jj(qu,ms,an,0,0,0)-jj(0,1,an,0,0,0));
end;

function IfVisible(ralpha,rdelta,long,lat,TimeZone:extended):Boolean;
var
   present: tdatetime;
   jd,jd0,sc,mdl,tps,eps,jdm,azm,htr,asd,dec,dpsi,deps,ts,dts,ah,dah,x,y,lng:extended;
   annee,mois,jour,heure,mi,sec,msec:word;
   j,ms,an,hr,mn,ss,idx:longint;
   buf,tmp:string;
   str: string;
   flglc:boolean;

   hcomp,h0,m0,m1,ratio,m2,num,den,ho,l,h,time1,time2,d,TIME:   extended;

function dmod(x,y:real):real;
  begin dmod:=x-int(x/y)*y; end;

  function sin2(x:real):real;
  begin sin2:=sin(dmod(x,6.283185307179586)); end;

  function cos2(x:real):real;
  begin cos2:=cos(dmod(x,6.283185307179586)); end;

  function sin2a(x:real):real;
  begin  x:=(pi*x)/180;
       sin2a:=sin(dmod(x,6.283185307179586)); end;

  function cos2a(x:real):real;
  begin x:=(pi*x)/180;
      cos2a:=cos(dmod(x,6.283185307179586)); end;

begin
   present:=now;
   DecodeDate(present, Annee, Mois, Jour);
   DecodeTime(Present, Heure, Mi, Sec, MSec);
   TIME:=Heure+((Mi+(Sec/60))/60);
   j:=Jour;
   ms:=Mois;
   an:=Annee;
   mn:=Mi;
   hr:=Heure;
   sc:=Sec+MSec/1000;
   jd0:=jj(j,ms,an,hr,mn,sc);
   jd:=jd0;

   lng:=long;
   if((TimeZone>0) AND (long>0)) then
             lng:=360-lng;

   asd:=ralpha;
   dec:=rdelta;

   mdl:=5;
    while (abs(86400000.0*mdl)>1) do
     begin
      CalcNut(jd,dpsi,deps);
      tps:=(jd-2451545)/365250;
      eps:=(84381448-tps*(468150+tps*(59-1813*tps)))/1000;
      eps:=(eps+deps)*pi/648000.0;
      cal(jd,j,ms,an,hr,mn,sc);
      tps:=(jd-2451545)/36525;
      ts:=24110.54841+tps*(8640184.812866+tps*(0.093104-0.0000062*tps))+((dpsi*cos(eps))/15);
      ts:=ts+(240*lng)+3600*hr+60*mn+sc;
      ts:=ts-86400*int(ts/86400);
      if (ts<0) then ts:=ts+86400;
      ts:=pi*ts/43200.0;
      dts:=pi*(8640184.812866+tps*(0.186208-0.0000186*tps))/136328832000000.0;
      dts:=(dts+pi/43200);
      ah:=ts-pi*asd/12;
      if (ah>pi) then ah:=ah-2*pi;
      dah:=86400*dts;
      mdl:=ah/dah;
      jd:=jd-mdl;
      while (24*(jd-jd0)>25) do jd:=jd-1;
      while (jd<jd0) do jd:=jd+1;
     end;
     {PASSAGE}
     cal(jd,j,ms,an,hr,mn,sc);

   ho:=-0.5667;

   m0:=(hr+mn/60+sc/3600)/24;
   num:=sin2a(ho)-sin2a(lat)*sin2a(DEC);
   den:=cos2a(lat);
   den:=den*cos2a(DEC);
   ratio:=num/den;

   h0:=90;

   if abs(ratio)<=1 then
   begin
    h0:=abs(arctan(ratio/sqrt(-ratio*ratio+1)));
    if ratio<0 then h0:=h0+pi/2 else h0:=pi/2-h0;
    h0:=(h0*180)/pi;
   end;

   if h0<0 then h0:=180+h0;
   if h0>180 then h0:=h0-180;

   if m0<0 then m0:=m0+1;
   if m0>1 then m0:=m0-1;

    m1:=m0-h0/360;
    m2:=m0+h0/360;

    if m1>1 then m1:=m1-1;
    if m1<0 then m1:=m1+1;
    if m2<0 then m2:=m2+1;
    if m2>1 then m2:=m2-1;

    time1:=24*m1-TimeZone;
    if time1>24 then time1:=time1-24;
    if time1<0 then time1:=time1+24;
    time2:=24*m2-TimeZone;
    if time2>24 then time2:=time2-24;
    if time2<0 then time2:=time2+24;

    if time2 < time1
     then
      begin
       if (TIME<time2) and (TIME<time1) then TIME := TIME + 24;
       time2:= time2 + 24;
      end;
    if (TIME<time2) and (TIME>time1)
     then
         IfVisible:=true
     else
         IfVisible:=false;
end;

function HeureSiderale(long :extended;GMT : integer):extended;
var
   present: tdatetime;
   jd,jd0,sc,tps,eps,dpsi,deps,ts,lng,temp:extended;
   annee,mois,jour,heure,mi,sec,msec:word;
   j,ms,an,hr,mn:longint;

begin
   present:=now;
   present:=inchour(present,GMT);
   DecodeDate(present, Annee, Mois, Jour);
   DecodeTime(Present, Heure, Mi, Sec, MSec);
   j:=Jour;
   ms:=Mois;
   an:=Annee;
   mn:=Mi;
   hr:=Heure;

   sc:=Sec+MSec/1000;
   jd0:=jj(j,ms,an,hr,mn,sc);
   jd:=jd0;

   lng:=long;
   //if long>0 then
             //lng:=360-lng;
             
   //cal(jd,j,ms,an,hr,mn,sc);
   CalcNut(jd,dpsi,deps);
   tps:=(jd-2451545)/365250;
   eps:=(84381448-tps*(468150+tps*(59-1813*tps)))/1000;
   eps:=(eps+deps)*pi/648000.0;
   tps:=(jd-2451545)/36525;
   ts:=24110.54841+tps*(8640184.812866+tps*(0.093104-0.0000062*tps))+((dpsi*cos(eps))/15);
   ts:=ts+(240*lng)+3600*hr+60*mn+sc;
   ts:=ts-86400*int(ts/86400);
   if (ts<0) then ts:=ts+86400;
   temp:=24*ts/86400;
   if(temp<0) then temp:=24+temp;
   result := temp*pi/12;
end;

function AH(long,alpha :extended;GMT : integer):extended;    {Angle Horaire}
var
   temp:extended;

begin
   temp:=HeureSiderale(Long,GMT)-alpha;
   if (temp>pi) then temp:=temp-2*pi;
   result:=temp;
end;

Function getKingSpeedCorrection(AH,Delta,Latitude:Double):Double;

const VitesseNormale=86164.101/60; //sec = 23h 56m 04s -> 1436.07 par 24h
var   DenominateurSimple,Denominateur,Inter:Double;
      VitesseKing,Numerateur:Double;

begin

 try


  DenominateurSimple:=(sin(Latitude)*sin(Delta)+cos(Delta)*cos(Latitude)*cos(AH));
  Denominateur      :=Cos(Delta)    * sqr(DenominateurSimple);

  Numerateur        :=cos(Latitude) *  ( cos(Latitude)*cos(Delta) +
                                         sin(Delta)*sin(Latitude)*cos(AH)
                                        );

  Inter             :=cos(AH)*Tan(Delta)/Tan(Latitude);

  VitesseKing:=VitesseNormale + 0.4*((Numerateur/Denominateur)-Inter);

  Result:=VitesseKing/VitesseNormale;

 except
  Result:=1;
 end;

end;

procedure CalculeAlphaDeltaFromAZ(Ht,Az,Tsl:Double;var Alpha,Delta:double;Latitude,Longitude:Double);
var Ha:Double;
begin
 Az:=Az-Pi;
 Delta:=Arcsin(Sin(Latitude)*Sin(ht)-
               Cos(Latitude)*Cos(ht)*Cos(Az));

 if Abs(Delta)=Pi/2.0 then
  Ha:=0
 else
 if Abs(Latitude)=Pi/2.0 then
  Ha:=Az
 else Ha:=ArcCos(
                 (Sin(ht)-Sin(Latitude)*Sin(Delta))/
                 (Cos(Latitude)*Cos(Delta))
                );

  if Az<0 then
   Alpha:=Tsl+Ha
  else
   Alpha:=Tsl-Ha;
end;

procedure CorrectionRefraction(var Alpha,Delta:Double;HeureSid:Double;Latitude,Longitude:Double);
var HauteurApparente,Azimuth,Hauteur:Double;
    Angle_Horaire:Double;
    DecalageHauteur:Double;

    testAlpha,TestDelta:Double;
begin
 Angle_Horaire:=HeureSid-Alpha;

 HauteurApparente:=Arcsin((cos(Angle_Horaire)*cos(Latitude)*cos(Delta))+
                 (sin(Latitude)*sin(Delta)));


 if HauteurApparente>0 then
 begin
  if cos(hauteurApparente)*cos(Latitude) <>0 then
  begin
   Azimuth:=Arccos(
                   (sin(Delta) - (Sin(hauteurApparente)*sin(Latitude)))/
                   (-cos(HauteurApparente)*cos(Latitude))
                   );

    if (Cos(Delta)*sin(Angle_Horaire))/cos(HauteurApparente)<0 then
     Azimuth:=Azimuth+Pi;
    if Angle_Horaire > 2*Pi then Angle_Horaire := Angle_Horaire - 2*Pi;

    if (Angle_Horaire>=0) and (Angle_Horaire<Pi) then
     Azimuth:=Azimuth+Pi;
    if (Angle_Horaire>=Pi)and (Angle_Horaire<2*Pi) then
     Azimuth:=2*Pi-Azimuth;
   end
  else
   if Abs(Latitude)<>Pi/2.0 then
    Azimuth:=0.0
   else
    Azimuth:=Angle_Horaire+Pi;



 if HauteurApparente>0.000001 then
 begin
  DecalageHauteur:=58.294*tan(Pi/2-HauteurApparente)-0.0668*tan(Pi/2-HauteurApparente);
  Hauteur:=HauteurApparente-(DecalageHauteur/3600)*Pi/180;
  if Hauteur>Pi/2 then
  begin
   Hauteur:=Pi-Hauteur;
   Azimuth:=Azimuth+Pi;
   if Azimuth > 2*Pi then Azimuth := Azimuth - 2*Pi;
  end;


  CalculeAlphaDeltaFromAZ(Hauteur,Azimuth,HeureSid,Alpha,Delta,Latitude,Longitude);
 end;
end;
end;


procedure CorrectionRefractionInverse(var Alpha,Delta:Double;HeureSid:Double;Latitude,Longitude:Double);
var HauteurApparente,Azimuth,Hauteur:Double;
    Angle_Horaire:Double;
    DecalageHauteur:Double;

    testAlpha,TestDelta:Double;
begin
 Angle_Horaire:=HeureSid-Alpha;

 HauteurApparente:=Arcsin((cos(Angle_Horaire)*cos(Latitude)*cos(Delta))+
                 (sin(Latitude)*sin(Delta)));


 if HauteurApparente>0 then
 begin
  if cos(hauteurApparente)*cos(Latitude) <>0 then
  begin
   Azimuth:=Arccos(
                   (sin(Delta) - (Sin(hauteurApparente)*sin(Latitude)))/
                   (-cos(HauteurApparente)*cos(Latitude))
                   );

    if (Cos(Delta)*sin(Angle_Horaire))/cos(HauteurApparente)<0 then
     Azimuth:=Azimuth+Pi;
    if Angle_Horaire > 2*Pi then Angle_Horaire := Angle_Horaire - 2*Pi;

    if (Angle_Horaire>=0) and (Angle_Horaire<Pi) then
     Azimuth:=Azimuth+Pi;
    if (Angle_Horaire>=Pi)and (Angle_Horaire<2*Pi) then
     Azimuth:=2*Pi-Azimuth;
   end
  else
   if Abs(Latitude)<>Pi/2.0 then
    Azimuth:=0.0
   else
    Azimuth:=Angle_Horaire+Pi;



 if HauteurApparente>0.000001 then
 begin
  DecalageHauteur:=58.294*tan(Pi/2-HauteurApparente)-0.0668*tan(Pi/2-HauteurApparente);
  Hauteur:=HauteurApparente+(DecalageHauteur/3600)*Pi/180;
  if Hauteur>Pi/2 then
  begin
   Hauteur:=Pi-Hauteur;
   Azimuth:=Azimuth+Pi;
   if Azimuth > 2*Pi then Azimuth := Azimuth - 2*Pi;
  end;


  CalculeAlphaDeltaFromAZ(Hauteur,Azimuth,HeureSid,Alpha,Delta,Latitude,Longitude);
 end;
end;
end;


procedure CalcNut(jd:extended;var dpsi,deps:extended);
var
 m0,m9,f,d,om,t:extended;
begin
 t:=(jd-2451545.0)/365250.0;
 m9:=485867.28096+t*(17179159234.728+t*(3238.93+t*(51.651-2.44*t)));
 m0:=1287104.79306+t*(1295965810.474+t*(0.147*t-55.29));
 f:=335779.55755+t*(17395272630.983-t*(1225.05+t*(1.021-t*0.0417)));
 d:=1072260.73512+t*(16029616014.603-t*(586.81-t*(6.595-0.3184*t)));
 om:=450160.39816-t*(69628902.656-t*(747.42+t*(7.702-t*0.5939)));
 m9:=pi*(m9-1296000.0*int(m9/1296000.0))/648000;
 m0:=pi*(m0-1296000.0*int(m0/1296000.0))/648000;
 f:=pi*(f-1296000.0*int(f/1296000.0))/648000;
 d:=pi*(d-1296000.0*int(d/1296000.0))/648000;
 om:=pi*(om-1296000.0*int(om/1296000.0))/648000;
 dpsi:=-(171996+1742*t)*sin(om)+(2062+2*t)*sin(2*om);
 dpsi:=dpsi+46*sin(2*(f-m9)+om)+11*sin(2*(m9-f));
 dpsi:=dpsi-(13187+16*t)*sin(2*(f-d+om))+(1426-34*t)*sin(m0);
 dpsi:=dpsi-(517-12*t)*sin(m0+2*(f-d+om));
 dpsi:=dpsi+(217-5*t)*sin(2*(f-d+om)-m0);
 dpsi:=dpsi+(129+t)*sin(2*(f-d)+om)+48*sin(2*(m9-d));
 dpsi:=dpsi-22*sin(2*(f-d))+(17-t)*sin(2*m0)-15*sin(m0+om);
 dpsi:=dpsi-(16-t)*sin(2*(m0+f-d+om))-12*sin(om-m0);
 dpsi:=dpsi-(2274+2*t)*sin(2*(f+om))+(712+t)*sin(m9);
 dpsi:=dpsi-(386+4*t)*sin(2*f+om)-301*sin(m9+2*(f+om));
 dpsi:=dpsi-158*sin(m9-2*d)+123*sin(2*(f+om)-m9)+63*sin(2*d);
 dpsi:=dpsi+(63+t)*sin(m9+om)-(58+t)*sin(om-m9);
 dpsi:=dpsi-59*sin(2*(f+d+om)-m9)-51*sin(m9+2*f+om);
 dpsi:=dpsi-38*sin(2*(f+d+om))+29*sin(2*m9)+29*sin(m9+2*(f-d+om));
 dpsi:=dpsi-31*sin(2*(m9+f+om))+26*sin(2*f)+21*sin(2*f+om-m9);
 dpsi:=dpsi+16*sin(2*d+om-m9)-13*sin(m9-2*d+om);
 dpsi:=dpsi-10*sin(2*(f+d)+om-m9)-8*sin(m9+2*(f+d+om));
 dpsi:=dpsi+7*(sin(m0+2*(f+om))+sin(-m0+2*(f+om))-sin(m9+m0-2*d)-sin(2*(f+d)+om));
 dpsi:=dpsi+6*(sin(m9+2*d)+sin(2*(m9+f-d-om))-sin(2*d+om)+sin(m9+2*(f-d)+om)-sin(+2*(d-m9)+om));
 dpsi:=dpsi+5*(sin(m9-m0)-sin(om-2*d)-sin(2*(m9+f)+om)-sin(2*(f-d)+om-m0));
 dpsi:=dpsi+4*(sin(2*(m9-d)+om)+sin(m0+om+2*(f-d))-sin(m9-d));
 dpsi:=dpsi+4*(sin(m9-2*f)-sin(m0-2*d)-sin(d)-sin(2*(f+om-m9))-sin(m9-m0-d));
 dpsi:=dpsi+3*(sin(m9+2*f)-sin(m9+m0)-sin(m9-m0+2*(f+om)));
 dpsi:=dpsi-3*(sin(2*(f+d+om)-m9-m0)+sin(3*m9+2*(f+om))+sin(2*(f+d+om)-m0));
 dpsi:=dpsi+2*(sin(m9+m0+2*(f+om))-sin(2*(f-d)+om-m9)-sin(om-2*m9));
 dpsi:=dpsi+2*(sin(2*m9+om)-sin(4*d+2*(om+f)-m9)-sin(m9+2*om));
 dpsi:=dpsi+2*(sin(3*m9)+sin(2*(f+om)+d)-sin(2*(f-m0-d)+om));
 dpsi:=dpsi+sin(2*(m9-d)+m0)+sin(2*(d-f)+om)-sin(m0+2*(d-f));
 dpsi:=dpsi+sin(m0+2*om)+sin(d-m9+om)-sin(m0+2*(f-d));
 dpsi:=dpsi+sin(2*om-m9)-sin(m9-4*d)+sin(2*(f+d+om-m9))-sin(2*m9-4*d);
 dpsi:=dpsi+sin(m9+m0+2*(f-d+om))-sin(m9+om+2*(f+d))-sin(2*(2*d+om+f-m9));
 dpsi:=dpsi+sin(4*f+2*om-m9)+sin(m9-m0-2*d)+sin(2*(m9+f-d)+om);
 dpsi:=dpsi-sin(2*(m9+f+d+om))-sin(m9+2*d+om)+sin(2*(2*f-d+om));
 dpsi:=dpsi+sin(3*m9+2*(f-d+om))-sin(m9+2*(f-d))+sin(m0+2*f+om);
 dpsi:=dpsi+sin(2*d+om-m9-m0)-sin(om-2*f)-sin(2*(f+om)-d);
 dpsi:=dpsi-sin(m0+2*d)-sin(m9-2*(f+d))-sin(2*f+om-m0)+sin(2*(m9-f)+om);
 dpsi:=dpsi+sin(2*(m9+d))-sin(m9+m0+om-2*d)-sin(m9+2*(d-f));
 dpsi:=dpsi+sin(m0+d)-sin(2*(2*d+f+om));
 dpsi:=10*dpsi-sin(3*m9+2*(f+d+om))-2*sin(m9+2*(f+om+2*d))-3*sin(4*m9+2*(f+om));
 dpsi:=dpsi-2*sin(2*(m9+f+d)+om)-sin(2*f+4*d+om)-5*sin(3*m9+2*f+om);
 dpsi:=dpsi+sin(m9+m0+2*(f+d+om))-6*sin(m9-m0+2*(f+d+om))-3*sin(2*f+4*d+om-m9);
 dpsi:=dpsi-2*sin(2*(f+om+2*d)-m9-m0)+4*sin(2*(m9+f+om)+m0)+2*sin(4*f-2*om);
 dpsi:=dpsi+3*sin(2*(m9+f))+5*sin(m0+2*(f+d+om))+3*sin(m9+d+2*(f+om));
 dpsi:=dpsi-5*sin(2*(m9+f+om)-m0)+4*sin(2*(f+d))-sin(2*(m9+d)-om);
 dpsi:=dpsi-4*sin(2*(f+d)+om-m0)-2*sin(4*d+2*(f-m9)+om)-sin(2*(om+d+f-m0));
 dpsi:=dpsi+5*sin(4*d)-2*sin(4*d+om)+2*sin(4*f+2*(om-d)+m9);
 dpsi:=dpsi+2*sin(3*m9+2*(f-d)+om)+4*sin(2*f+m0+m9+om)+2*sin(4*f+om-m9);
 dpsi:=dpsi-2*sin(2*(f+om)+m0+d)-sin(om-3*m9)+6*sin(2*(f+d+om)+m0-m9);
 dpsi:=dpsi+3*sin(2*f+d+om)-4*sin(m9-m0+2*f+om)-4*sin(om-m9-2*d);
 dpsi:=dpsi-5*sin(2*(f+d)+om-m9-m0)+5*sin(m9-m0+2*d)-sin(m9-4*d+om);
 dpsi:=dpsi-2*sin(4*d+om-m9)+sin(4*d-m9-m0)+3*sin(2*(m9+f-d+om)+m0);
 dpsi:=dpsi+2*sin(4*f-2*d+om)-3*sin(m9-d+2*(f+om))-3*sin(2*m9+m0)-sin(2*f+om);
 dpsi:=dpsi+2*sin(2*f+3*om)+2*sin(m0+om+2*d)-3*sin(m9+d)+4*sin(2*m9-m0);
 dpsi:=dpsi+2*sin(2*(f+d-m9)+om)+sin(2*(om-d))-5*sin(2*(d+om));
 dpsi:=dpsi-3*sin(m0+om-2*d)-2*sin(2*d+om-m0)-sin(2*m9-4*d+om);
 dpsi:=dpsi+sin(4*d-2*m9+om)+2*sin(2*(d-m0))-sin(2*f-4*d+om);
 dpsi:=dpsi+3*sin(m9+m0+om+2*(f-d))+4*sin(2*(f+om)+m0-m9)+2*sin(om-m9-m0);
 dpsi:=dpsi-3*sin(m9+m0+om)+3*sin(m9-2*f+om)-2*sin(f+om);
 dpsi:=dpsi-2*sin(2*(f+om)-m9-m0)-sin(2*d+om-m9+m0)+3*sin(om-d);
 dpsi:=dpsi-4*sin(d+om)-2*sin(m0+om-m9)+5*sin(m9-m0+om)+3*sin(m9+2*(om-d));
 dpsi:=dpsi-4*sin(2*(d+om)-m9)+3*sin(2*(om+f-d)-m9)-sin(2*(f-d)+om+m0-m9);
 dpsi:=dpsi+3*sin(2*(d-m0)-m9)-4*sin(m9+om+2*f-4*d)-5*sin(3*m0+2*(f+om-d));
 dpsi:=dpsi+3*sin(3*m0)-2*sin(2*(d-m9)+om-m0)-9*sin(2*(f-d)+om)-sin(om-2*m0);
 dpsi:=dpsi+12*sin(2*(f-d)+3*om)-3*sin(2*(m9+om-d))-sin(om+m0+2*(f-m9));
 dpsi:=dpsi-sin(m0+2*(f+om-m9))-4*sin(2*f-d-m9+om)+3*sin(2*om-m0);
 dpsi:=dpsi+2*sin(m9-d+om)+4*sin(2*(f+om-m9)-m0)+4*sin(2*(f-m9)+om-m0);
 dpsi:=dpsi+2*sin(2*(f+om)+d-3*m9)-2*sin(3*om)+13*sin(2*(f+om)-m9-m0-d);
 dpsi:=dpsi-15*sin(f+om-m9)+3*sin(f-m9+2*om)+7*sin(m0-m9+d+om);
 dpsi:=dpsi-sin(2*(m9+f+d+om)-m0)-sin(4*d+2*(om+f)-m0)-sin(3*m9+2*(f+om)-m0);
 dpsi:=dpsi-sin(2*(f+d-m0)+om+m9)+sin(m9+4*d)+sin(4*m9+2*(f+om-d));
 dpsi:=dpsi+sin(2*(m9+f)+m0+om)+sin(4*m9)+sin(m0+om+2*(f+d))+sin(m9+d+om+2*f);
 dpsi:=dpsi-sin(2*(m9+f)+om-m0)+sin(2*(f+om)+3*d-m9)-sin(4*d+2*(f+om-m9)-m0);
 dpsi:=dpsi+sin(4*d-m0)-sin(2*(m9+f+om)-d)+sin(m9-om+2*f)+sin(3*m9+om);
 dpsi:=dpsi+sin(2*(f+d)+om-m9+m0)-sin(m9+m0+2*d)-sin(m9-m0+om+2*d);
 dpsi:=dpsi-sin(2*(f+d+om-m0)-m9)+sin(2*(m9+f-d)+om+m0)+sin(2*(m0+f+om));
 dpsi:=dpsi-sin(2*(m9+f-d))-sin(4*f+2*(om-m9))+sin(m9+m0+d)-sin(2*(m9+om));
 dpsi:=dpsi+sin(2*(f+om)+d-m9)-sin(2*d+m0-om)-sin(2*(f+om-m0));
 dpsi:=dpsi+sin(2*(m9+d-f)-om)+sin(2*(f+d+om-m9)-m0)-sin(3*d-m9);
 dpsi:=dpsi+sin(4*d-2*m9-m0)-sin(4*f+2*(om-d)-m9)-sin(m9+2*m0);
 dpsi:=dpsi+sin(2*f+om-m9+m0)-sin(2*f-d+om)-sin(m9-m0+om+2*(f-d));
 dpsi:=dpsi-sin(m9-m0+2*(f+om-d))+sin(2*m9-d)-sin(2*(m0+d)-m9);
 dpsi:=dpsi+sin(2*(f+om)-m0-d)+sin(3*m9-2*f-om)-sin(2*f-m9-m0+om);
 dpsi:=dpsi-sin(2*d-m9+m0-om)+sin(2*(f+d)-3*m9+om)+sin(m9-2*m0)-sin(3*d-2*m9);
 dpsi:=dpsi+sin(4*d-3*m9)-sin(4*d-2*(f+om)-m9)-sin(4*d-2*f-m9);
 dpsi:=dpsi+sin(4*d-2*(f+om)-m9-m0)-sin(m9+m0+om+2*f-4*d)+sin(2*(m0+f-d)+om);
 dpsi:=dpsi-sin(2*(m9+f+om)-4*d)+sin(2*(m9-d)+m0+om)-sin(4*f+2*(om-m9-d));
 dpsi:=dpsi-sin(2*(m0+f+om-m9))-sin(2*m0+om)+sin(m9-m0+2*(f+om)-3*d);
 dpsi:=dpsi-sin(2*(f+d+om)-4*m9);
 deps:=(92025+89*t)*cos(om)-(895-5*t)*cos(2*om)-24*cos(2*(f-m9)+om);
 deps:=deps+(5736-31*t)*cos(2*(f-d+om))+(54-t)*cos(m0);
 deps:=deps+(224-6*t)*cos(m0+2*(f-d+om))-(95-3*t)*cos(2*(f-d+om)-m0);
 deps:=deps-70*cos(2*(f-d)+om)+(977-5*t)*cos(2*(f+om))-7*cos(m9);
 deps:=deps+(200-t)*cos(2*f+om)+129*cos(m9+2*(f+om))-cos(m9-2*d);
 deps:=deps-53*cos(2*(f+om)-m9)-33*cos(m9+om)+32*cos(om-m9);
 deps:=deps+26*cos(2*(f+d+om)-m9)+27*cos(m9+2*f+om)+16*cos(2*(f+d+om));
 deps:=deps-cos(2*m9)-12*cos(m9+2*(f-d+om))+13*cos(2*(m9+f+om))-cos(2*f);
 deps:=deps-10*cos(2*f+om-m9)+9*cos(m0+om)-8*cos(2*d+om-m9)+6*cos(om-m0);
 deps:=deps+7*(cos(m9-2*d+om)+cos(2*(m0+f-d+om)));
 deps:=deps+5*(cos(2*(f+d)+om-m9)+cos(m9+m0-2*d));
 deps:=deps+3*(cos(m9+2*(f+d+om))+cos(m9+2*d)+cos(2*(f+d)+om));
 deps:=deps+3*(cos(m9+2*(f-d)+om)+cos(m9-m0)+cos(m0-2*d));
 deps:=deps+3*(cos(2*(d-m9)+om)+cos(2*(f-d)+om-m0));
 deps:=deps-3*(cos(2*(f+om)-m0)+cos(2*d+om)+cos(om-2*d));
 deps:=deps-2*(cos(2*(m9-d)+om)+cos(m0+2*(f-d)+om)-cos(2*d));
 deps:=deps+cos(2*(f-d-m0)+om)+cos(2*(f+om-m9))+cos(2*(m9-d));
 deps:=deps+cos(m9-m0+2*(f+om))+cos(2*(f+d+om)-m9-m0);
 deps:=deps+cos(om-2*m9)+cos(3*m9+2*(f+om))+cos(2*(f+d+om)-m0);
 deps:=deps-cos(m9+m0+2*(f+om))+cos(2*(f-d)+om-m9)-cos(2*m9+om);
 deps:=deps+cos(m9+2*om)-cos(2*(f+om)+d)-cos(2*om-m9)-cos(2*(f+d+om-m9));
 deps:=deps+cos(2*(2*d+f+om)-m9)-cos(m9+m0+2*(f-d+om))+cos(2*(f+d)+m9+om);
 deps:=deps+cos(2*(2*d-m9+f+om))-cos(2*(m9+f-d)+om);
 deps:=10*deps+cos(3*m9+2*(f+d+om))+cos(m9+2*(f+om+2*d))+cos(4*m9+2*(f+om));
 deps:=deps+cos(2*(m9+f+d)+om)+cos(2*f+4*d+om)+2*cos(3*m9+2*f+om);
 deps:=deps-cos(m9+m0+2*(f+d+om))+2*cos(m9-m0+2*(f+d+om))+cos(2*f+4*d+om-m9);
 deps:=deps+cos(2*(f+om+2*d)-m9-m0)-2*cos(2*(m9+f+om)+m0)-cos(4*f-2*om);
 deps:=deps-2*cos(m0+2*(f+d+om))-cos(m9+d+2*(f+om))+2*cos(2*(m9+f+om)-m0);
 deps:=deps+cos(2*(m9+d)-om)+2*cos(2*(f+d)+om-m0)+cos(4*d+2*(f-m9)+om);
 deps:=deps+cos(2*(om+d+f-m0))+cos(4*d+om)-cos(4*f+2*(om-d)+m9);
 deps:=deps-cos(3*m9+2*(f-d)+om)-2*cos(2*f+m0+m9+om)-cos(4*f+om-m9);
 deps:=deps+cos(2*(f+om)+m0+d)+cos(om-3*m9)-2*cos(2*(f+d+om)+m0-m9);
 deps:=deps-cos(2*f+d+om)+2*cos(m9-m0+2*f+om)+3*cos(om-m9-2*d);
 deps:=deps+2*cos(2*(f+d)+om-m9-m0)+cos(m9-4*d+om)+cos(4*d+om-m9);
 deps:=deps-cos(2*(m9+f-d+om)+m0)-cos(4*f-2*d+om)+cos(m9-d+2*(f+om));
 deps:=deps-cos(m0+om+2*d)-cos(2*(f+d-m9)+om)-cos(2*(om-d))+2*cos(2*(d+om));
 deps:=deps+2*cos(m0+om-2*d)+cos(2*d+om-m0)+cos(2*m9-4*d+om);
 deps:=deps-cos(4*d-2*m9+om)+cos(2*f-4*d+om)-cos(m9+m0+om+2*(f-d));
 deps:=deps-2*cos(2*(f+om)+m0-m9)-cos(om-m9-m0)+2*cos(m9+m0+om)-cos(m9-2*f+om);
 deps:=deps+cos(2*(f+om)-m9-m0)+cos(2*d+om-m9+m0)-2*cos(om-d)+2*cos(d+om);
 deps:=deps+2*cos(m0+om-m9)-3*cos(m9-m0+om)-cos(m9+2*(om-d));
 deps:=deps+2*cos(2*(d+om)-m9)-cos(2*(om+f-d)-m9)+cos(2*(f-d)+om+m0-m9);
 deps:=deps+2*cos(m9+om+2*f-4*d)+2*cos(3*m0+2*(f+om-d))+cos(2*(d-m9)+om-m0);
 deps:=deps+7*cos(2*(f-d)+om)+cos(om-2*m0)-2*cos(2*(f-d)+3*om);
 deps:=deps+cos(2*(m9+om-d))+cos(2*f-d-m9+om)-cos(2*om-m0)-cos(m9-d+om);
 deps:=deps-2*cos(2*(f+om-m9)-m0)-cos(2*(f+om)+d-3*m9)-5*cos(2*(f+om)-m9-m0-d);
 deps:=deps+3*cos(f+om-m9)-cos(f-m9+2*om)-4*cos(m0-m9+d+om);
 dpsi:=dpsi/100000;
 deps:=deps/100000;
end;

procedure ReducPole(jd:extended;var a0,d0:extended);
var
 i,j:longint;
 eps0,eps1,t,pa,gpa,ppa,csa,sna,csb,snb,csc,snc,csd,snd,cse,sne,dpsi,deps,wrk:extended;
 ma:array[1..3,1..3] of extended;
 p0,p1:array[1..3] of extended;
begin
 t:=(jd-2451545)/365250;
 CalcNut(jd,dpsi,deps);
 eps0:=pi*10547681.0/81000000.0;
 eps1:=eps0+pi*t*((1813*t-59)*t-468150)/648000000.0;
 ppa:=pi*((60*t-3302)*t+470029)*t/648000000.0;
 gpa:=pi*((3536*t+8698089)*t+629554982)/648000000.0;
 pa:=pi*((111113-6*t)*t+50290966)*t/648000000.0;
 eps1:=eps1+(pi*deps/648000);
 pa:=pa+gpa+(pi*dpsi/648000);
 csa:=cos(eps0);
 csb:=cos(gpa);
 csc:=cos(ppa);
 csd:=cos(pa);
 cse:=cos(eps1);
 sna:=sin(eps0);
 snb:=sin(gpa);
 snc:=sin(ppa);
 snd:=sin(pa);
 sne:=sin(eps1);
 ma[1,1]:=csd*csb+snd*csc*snb;
 ma[1,2]:=(csd*snb-snd*csc*csb)*csa+snd*snc*sna;
 ma[1,3]:=(csd*snb-snd*csc*csb)*sna-snd*snc*csa;
 ma[2,1]:=(snd*csb-csd*csc*snb)*cse-snb*snc*sne;
 ma[2,2]:=cse*(snd*snb*csa+csd*(csc*csb*csa-snc*sna))+sne*(snc*csb*csa+csc*sna);
 ma[2,3]:=cse*(snd*snb*sna+csd*(csc*csb*sna+snc*csa))+sne*(snc*csb*sna-csc*csa);
 ma[3,1]:=(snd*csb-csd*csc*snb)*sne+snb*snc*cse;
 ma[3,2]:=sne*(snd*snb*csa+csd*(csc*csb*csa-snc*sna))-cse*(snc*csb*csa+csc*sna);
 ma[3,3]:=sne*(snd*snb*sna+csd*(csc*csb*sna-snc*csa))-cse*(snc*csb*sna-csc*csa);
 p0[1]:=cos(a0)*cos(d0);
 p0[2]:=sin(a0)*cos(d0);
 p0[3]:=sin(d0);
 for i:=1 to 3 do
  begin
   p1[i]:=0.0;
   for j:=1 to 3 do p1[i]:=p1[i]+ma[i,j]*p0[j];
  end;
 if (p1[1]<>0) then a0:=arctan(p1[2]/p1[1]) else
  if (p1[2]<>0) then a0:=pi*p1[2]/abs(2*p1[2]) else a0:=0;
 if (p1[1]<0) then a0:=a0+pi;
 if (a0<0) then a0:=a0+2*pi;
 wrk:=sqrt(p1[1]*p1[1]+p1[2]*p1[2]);
 if (wrk<>0) then d0:=arctan(p1[3]/wrk) else d0:=pi*p1[3]/abs(2*p1[3]);
end;

end.
